from django.db import models
from isbnvalidate import isValidISBN
from django import forms

class ISBNField(models.Field):

  def __init__(self, *args, **kwargs):
    kwargs['max_length'] = 13
    super(ISBNField, self).__init__(*args, **kwargs)

  def clean(self, value):
    if not isValidISBN(value):
      raise forms.ValidationError("not a valid ISBN")
    else:
      return value
