from django.db import models
from django.contrib.auth.models import User
from books.models import Owner, Location
from tagging.fields import TagField
from tagging.models import Tag

class Catalogue(models.Model):
  title = models.CharField(max_length=255)
  artist = models.CharField(max_length=255, blank=True)
  exhibition = models.CharField(max_length=255, blank=True)
  published_date = models.DateField(blank=True, verbose_name="Published on")
  condition = models.TextField(blank=True)
  description = models.TextField(blank=True)
  owner = models.ForeignKey(Owner, blank=True)
  location = models.ForeignKey(Location, blank=True)
  tags = TagField("Tags", blank=True, help_text="Enter as many tags as you like, separated by commas")
  added_by = models.ForeignKey(User, editable=False)
  date_added = models.DateTimeField(auto_now=True, editable=False)
  def __unicode__(self):
    return self.name

  class Meta:
    verbose_name_plural = "Catalogues"

