import os
from os.path import join
from models import HardDrive, File

ERROR_LOG = open("errors.txt", "a")

def loopThroughDir(path):
  dir = os.listdir(path)
  for f in dir:
    if f.endswith('txt'):
      addHardDrive(f, path)
  ERROR_LOG.close()

def addHardDrive(filename, path):
  filePath = u''
  filePath = join(path, filename)
  hdName = filename.replace(".txt", "")
  file = open(filePath)
  if hardDriveExists(hdName):
    hd = hardDriveExists(hdName)
    hd.remove_files()
  else:
    hd = HardDrive(name = hdName)
    hd.save()
    print hdName
  for f in file:
    addFile(f, hd)

def addFile(filePath, hd):
  filename = u''
  filename = getFileNameFromPath(filePath)
  newfile = File(filename = filename, fullPath = filePath, hd = hd)
  try:
    newfile.save()
  except:
    err = hd.name + ":\n"
    err += filePath + "\n\n"
    ERROR_LOG.write(err)   
  print "added " + filename

def hardDriveExists(hdName):
  q = HardDrive.objects.filter(name=hdName)
  if q.count() > 0:
    return q[0]
  else:
    return False

def getFileNameFromPath(filePath):
  return os.path.basename(filePath)

if __name__ == '__main__':
  import sys
  if len(sys.argv) < 2:
    print "usage: %s <directory path>" % sys.argv[0]
    sys.exit()
  else:
    path = sys.argv[1]
    loopThroughDir(path)
