$(document).ready(function() {
  $('#lookupIsbn').click(isbnLookup);

//To handle colour changing on focus / blur of form elems:
  $('input, textarea').focus(function() {
    $(this).css("background", "#fff");
    }).blur(function() {
    $(this).css("background", "#ccc");
    });

//To add Owner / Location fields dynamically.
  $('.addButton').click(function() {
    var fieldName = $(this).attr("data_field");
    var value = prompt("Please type the name of the new " + fieldName + "you would like to add:");
    if (value != null && $.trim(value) != '') { 
      var url = "/add" + fieldName + "/";
      $.get(url, {
        'name': value
        }, function(response) {
        addedId = response;
        var html = '';
        html += '<option value="' + addedId + '" selected="selected">' + value + "</option>";
        selectId = "#id_" + fieldName;
        $(selectId).append(html);
        });
      }
    });
  })

//TODO: Make this a function that actually validates.
function isValidIsbn(isbn) {
  if ($.trim(isbn) != '') {
    return true;
    } else {
    return false;      
    }
  }

//Function fired on start loading ISBN Lookup
function doLoading() {
  $('.autoisbn').css("background", "#f00").attr("disabled", "true");
  $('#lookupIsbn').fadeOut();
  $('#loading').fadeIn();
  $('.loadingimage').fadeIn();
  $('.button_loadingimage').fadeIn();
  }

//Function fired when ISBN Lookup is loaded
function stopLoading() {
  $('.autoisbn').removeAttr("disabled").css("background", "#fff");
  $('#loading').hide();
  $('.loadingimage').fadeOut();
  $('.button_loadingimage').fadeOut();
  $('#lookupIsbn').fadeIn();
  }

//Fetch ISBN Lookup data and populate relevant fields.
function isbnLookup() {
  isbn = $('#id_isbn').val();
  if (isValidIsbn(isbn)) {
    doLoading();
    $.getJSON("/isbnlookup/", {
      'isbn': isbn 
    }, function(data) {
      if (data.errors && data.errors != '') {
        $('#formErrors').html(data.errors);
        stopLoading();
        } else {
//        alert(data.title);
        $('#id_title').val(data.title);
        $('#id_dimensions').val(data.dimensions);
        var publishedStr = getStrFromDate(data.published);
        $('#id_published').val(publishedStr);
        $('#id_publisher').val(data.publisher);
        if (data.weight != 0) {
          $('#id_weight').val(data.weight);
          }
        if (data.pages != 0) {
          $('#id_pages').val(data.pages);
          }
        if (data.tags.length > 0) {
          var tString = '';
          for (t in data.tags) {
            tString += data.tags[t] + ", ";
            }
          $('#id_autotags').val(tString);
          }
        $('#id_first_sentence').val(data.first_sentence);
//TODO: Formsets should be referencable by prefixes.
        formsets[0].populate(data.weblinks);
        formsets[1].populate(data.netReviews);
        formsets[2].populate(data.summaries);
        formsets[3].populate(data.relatedBooks);
        formsets[4].populate(data.imageUrls);
        formsets[5].populate(data.chapters);
        formsets[6].populate(data.sources);
        var authorString = '';
        for (author in data.authors) {
          authorString += data.authors[author] + "; ";
          }
//        alert(authorString);
        $('#id_authors').val(authorString);
        stopLoading();
        }
      });
    }
  }

//Isbn Lookup passes date as a dict - convert to string.
function getStrFromDate(d) {
  var str = '';
  if (d.year) {
    str += d.year
    if (d.month) {
      str += '-' + d.month
      if (d.day) {
        str += '-' + d.day
        }
      }
    }
  return str;
  }

//#################################################
//BEGIN Formset functions
//#################################################

var prefixes = ['weblinks', 'webreviews', 'summaries', 'relatedbooks', 'imageurls', 'chapters', 'sources']

//TODO: more elegant way to calculate length of buttons
$(document).ready(function() {
  formsets = [];
  for (var p in prefixes) {
    formsets[p] = new Formset(prefixes[p]);
    }

  $('.formset_title').hover(function() {
		$(this).css('border-color', '#fff');
		$(this).css('color', '#f00');
    }, function() {
		$(this).css('border-color', '#f00');
		$(this).css('color', '#fff');
    });
  });


